Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions
kArrayList Class Reference
kApi/Data

## Description

Represents a list implemented with a dynamic array.

The kArrayList class represents a dynamic, array-based list of objects or values. The kArrayList constructor accepts a kType value that determines the type of items that will be stored in the list. The list will automatically grow as new items are added.

kStatus ArrayListExample()
{
kArrayList list = kNULL;
k32s values[] = { 1, 2, 3, 5, 7, 9 };
kSize i;
kTry
{
//create a list that can store 32-bit integers
kTest(kArrayList_Construct(&list, kTypeOf(k32s), 0, kNULL));
//add some initial items to the list
for (i = 0; i < kCountOf(values); ++i)
{
kTest(kArrayList_Add(list, &values[i]);
}
//print some information about the list and its items
printf("Item type: %s\n", kType_Name(kArrayList_ItemType(list)));
printf("Count: %u\n", (k32u) kArrayList_Count(list));
for (i = 0; i < kArrayList_Count(list); ++i)
{
//the kArrayList_As_ macro can be used to get a list item and cast it to the desired type;
//this is equivalent to *(k32s*)kArrayList_At(list, i);
k32s value = kArrayList_As_(list, i, k32s);
printf("Item %u: %d\n", (k32u)i, value);
}
}
kFinally
{
kObject_Destroy(list);
kEndFinally();
}
return kOK;
}

For lists that contain objects (e.g. kImage) as opposed to values (e.g. k32s), the objects are not automatically destroyed when the list is destroyed. To recursively destroy both the list and the list items, use kObject_Dispose.

kArrayList supports the kObject_Clone, kObject_Dispose, and kObject_Size methods.

kArrayList supports the kdat5 and kdat6 serialization protocols.

Inheritance diagram for kArrayList:

## Public Member Functions
kStatus | kArrayList_Add (kArrayList list, const void *item)
| Adds the specified item to the end of the list. More...
kStatus | kArrayList_AddCount (kArrayList list, kSize count)
| Increases the list count by the specified amount. More...
kStatus | kArrayList_Allocate (kArrayList list, kType itemType, kSize initialCapacity)
| Reallocates the list item buffer. More...
kStatus | kArrayList_Append (kArrayList list, const void *items, kSize count)
| Appends the specified items to the list. More...
kStatus | kArrayList_Assign (kArrayList list, kArrayList source)
| Performs a shallow copy of the source list. More...
void * | kArrayList_At (kArrayList list, kSize index)
| Returns a pointer to the specified item in the list buffer. More...
kStatus | kArrayList_Attach (kArrayList list, void *items, kType itemType, kSize capacity)
| Attaches the list object to an external buffer. More...
kSize | kArrayList_Capacity (kArrayList list)
| Returns the number of elements for which space has been allocated. More...
kStatus | kArrayList_Clear (kArrayList list)
| Sets the count of list items to zero. More...
kStatus | kArrayList_Construct (kArrayList *list, kType itemType, kSize initialCapacity, kAlloc allocator)
| Constructs a kArrayList object. More...
kSize | kArrayList_Count (kArrayList list)
| Returns the current count of items in the list. More...
void * | kArrayList_Data (kArrayList list)
| Returns a pointer to the list item buffer. More...
kSize | kArrayList_DataSize (kArrayList list)
| Returns the total size of list data (Count x ItemSize), in bytes. More...
kStatus | kArrayList_Import (kArrayList list, const void *items, kType itemType, kSize count)
| Copies the specified items into the list, replacing existing contents. More...
kStatus | kArrayList_Insert (kArrayList list, kSize before, const void *item)
| Inserts an item into the list at the specified position. More...
kStatus | kArrayList_Item (kArrayList list, kSize index, void *item)
| Gets the value of an item. More...
kSize | kArrayList_ItemSize (kArrayList list)
| Returns the list element size. More...
kType | kArrayList_ItemType (kArrayList list)
| Returns the list element type. More...
kStatus | kArrayList_Purge (kArrayList list)
| Disposes any elements in the list and sets the count of list items to zero. More...
kStatus | kArrayList_Remove (kArrayList list, kSize index, void *item)
| Removes an item from the list at the specified index. More...
kStatus | kArrayList_RemoveCount (kArrayList list, kSize count)
| Decreases the list count by the specified amount. More...
kStatus | kArrayList_Reserve (kArrayList list, kSize capacity)
| Ensures that capacity is reserved for at least the specified number of list items. More...
kStatus | kArrayList_Resize (kArrayList list, kSize count)
| Sets the current count of list items to the specified value. More...
kStatus | kArrayList_SetItem (kArrayList list, kSize index, const void *item)
| Sets the value of an item. More...
kStatus | kArrayList_Zero (kArrayList list)
| Sets the memory for all list elements to zero. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
Public Member Functions inherited from kCollection
kSize | kCollection_Count (kCollection collection)
| Gets the collection element count. More...
kIterator | kCollection_GetIterator (kCollection collection)
| Returns an iterator to the first element in the collection. More...
kBool | kCollection_HasNext (kCollection collection, kIterator iterator)
| Determines whether a collection has another item. More...
kType | kCollection_ItemType (kCollection collection)
| Gets the collection element type. More...
void * | kCollection_Next (kCollection collection, kIterator *iterator)
| Gets the next collection element and then advances the iterator. More...

## Related
#define | kArrayList_AddCount_(LIST, C) kxArrayList_AddCount_(LIST, C)
| Macro version of kArrayList_AddCount.
#define | kArrayList_RemoveCount_(LIST, C) kxArrayList_RemoveCount_(LIST, C)
| Macro version of kArrayList_RemoveCount.
#define | kArrayList_Clear_(LIST) kxArrayList_Clear_(LIST)
| Macro version of kArrayList_Clear.
#define | kArrayList_ItemType_(LIST) kxArrayList_ItemType_(LIST)
| Macro version of kArrayList_ItemType.
#define | kArrayList_ItemSize_(LIST) kxArrayList_ItemSize_(LIST)
| Macro version of kArrayList_ItemSize.
#define | kArrayList_Count_(LIST) kxArrayList_Count_(LIST)
| Macro version of kArrayList_Count.
#define | kArrayList_Capacity_(LIST) kxArrayList_Capacity_(LIST)
| Macro version of kArrayList_Capacity.
#define | kArrayList_Data_(LIST) kxArrayList_Data_(LIST)
| Macro version of kArrayList_Data.
#define | kArrayList_DataSize_(LIST) kxArrayList_DataSize_(LIST)
| Macro version of kArrayList_DataSize.
#define | kArrayList_At_(LIST, INDEX) kxArrayList_At_(LIST, INDEX)
| Macro version of kArrayList_At.
#define | kArrayList_First_(LIST) kxArrayList_First_(LIST)
| Gets a pointer to the first item.
#define | kArrayList_Last_(LIST) kxArrayList_Last_(LIST)
| Gets a pointer to the last item.
#define | kArrayList_Begin_(LIST) kxArrayList_Begin_(LIST)
| Gets a pointer to the first item.
#define | kArrayList_End_(LIST) kxArrayList_End_(LIST)
| Gets a pointer to one past the last item.
#define | kArrayList_RBegin_(LIST) kxArrayList_RBegin_(LIST)
| Gets a pointer to the last item.
#define | kArrayList_REnd_(LIST) kxArrayList_REnd_(LIST)
| Gets a pointer to one before the first item.
#define | kArrayList_As_(LIST, INDEX, TYPE) kxArrayList_As_(LIST, INDEX, TYPE)
| Gets an item pointer and casts to the specified type.
Related inherited from kObject
#define | kObject_Type_(OBJ) kxObject_Type_(OBJ)
| Macro version of kObject_Type.
#define | kObject_Is_(OBJ, TYPE) kxObject_Is_(OBJ, TYPE)
| Macro version of kObject_Is.
#define | kObject_Alloc_(OBJ) kxObject_Allocator_(OBJ)
| Macro version of kObject_Alloc.

The documentation for this class was generated from the following file:

- Data/kArrayList.h